﻿using C1.DataCollection;
using FlexGrid101.Resources;
using System.Threading.Tasks;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace FlexGrid101
{
    [XamlCompilation(XamlCompilationOptions.Compile)]
    public partial class Grouping : ContentPage
    {
        C1DataCollection<Customer> _dataCollection;
        public Grouping()
        {
            InitializeComponent();

            this.Title = AppResources.GroupingTitle;
 
           

            var data = Customer.GetCustomerList(100);
            grid.ItemsSource = data;
            grid.MinColumnWidth = 85;

            var task = UpdateVideos();
        }

        private async Task UpdateVideos()
        {
            var grouping = grid.DataCollection as ISupportGrouping;
            await  grouping.GroupAsync(new GroupDescription[] { new GroupDescription("Country"), new GroupDescription("FirstName") });   
        }
    } 
}
